// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type GetLdapGroupDetailReq struct {
	Id int64 `form:"id"`
}

type SetLdapGroupAuthReq struct {
	GroupId   int64     `json:"group_id"`
	GroupAuth GroupAuth `json:"group_auth"`
}

type GroupAuth struct {
	Id       int64        `json:"id"`
	Name     string       `json:"name"`
	Type     string       `json:"type"`
	Metadata []*GroupAuth `json:"metadata,optional"`
}

type GetLdapGroupsReq struct {
	Id          int64  `form:"id,optional"`      //id
	Name        string `form:"name,optional"`    //名称
	Keyword     string `form:"keyword,optional"` //关键词
	Status      int64  `form:"status,optional"`  // 1正常, 2禁用
	Sort        string `form:"sort,optional"`
	CurrentPage int    `form:"current_page,optional,default=1"`
	PerPage     int    `form:"per_page,optional,default=10"`
}

type SaveLdapGroupReq struct {
	Id      int64  `json:"id"`      //id
	Type    string `json:"type"`    //类型
	Name    string `json:"name"`    //名称
	Keyword string `json:"keyword"` //关键词
	Remark  string `json:"remark"`  // 备注
	Status  int64  `json:"status"`  // 1正常, 2禁用
	Sort    int64  `json:"sort"`    // 排序
}

type DeleteLdapGroupReq struct {
	Ids []int64 `json:"ids"` //id
}

type DeleteApiReq struct {
	Ids []int64 `json:"ids"` //id
}

type SetLdapGroupMenusReq struct {
	GroupId int64   `json:"group_id"`
	MenuIds []int64 `json:"menu_ids"`
}

type SetLdapCasbinRuleReq struct {
	GroupId int64   `json:"group_id"`
	ApIds   []int64 `json:"api_ids"`
}

type GetApisReq struct {
	Sort        string `form:"sort,optional"`
	CurrentPage int    `form:"current_page,optional,default=1"`
	PerPage     int    `form:"per_page,optional,default=10"`
}

type SaveApiReq struct {
	Id       int64  `json:"id"`
	Name     string `json:"name"`
	Method   string `json:"method"`
	Path     string `json:"path"`
	Category string `json:"category"`
	Remark   string `json:"remark"`
}

type SaveMenuReq struct {
	Id       int64  `json:"id"`
	Name     string `json:"name"`
	Title    string `json:"title"`
	Icon     string `json:"icon"`
	Path     string `json:"path"`
	Sort     int64  `json:"sort"`
	ParentId int64  `json:"parent_id"`
	Status   int64  `json:"status,options=0|1"`
}

type DeleteMenuReq struct {
	Id int64 `json:"id"`
}

type GetMenuDetailReq struct {
	Id int64 `form:"id"`
}

type GetMenuDetailRsp struct {
	Id       int64  `json:"id"`
	Name     string `json:"name"`
	Title    string `json:"title"`
	Icon     string `json:"icon"`
	Path     string `json:"path"`
	Sort     int64  `json:"sort"`
	ParentId int64  `json:"parent_id"`
	Status   int64  `json:"status"`
}

type GetMenusReq struct {
	CurrentPage int    `form:"current_page,optional"`
	Name        string `form:"name,optional"`
	Title       string `form:"title,optional"`
	Path        string `form:"path,optional"`
	ParentId    *int64 `form:"parent_id,optional"`
}

type GetMenusRsp struct {
	List []MenuItem `json:"list"`
	Meta Meta       `json:"meta"`
}

type MenuItem struct {
	Id       int64  `json:"id"`
	Name     string `json:"name"`
	Title    string `json:"title"`
	Icon     string `json:"icon"`
	Path     string `json:"path"`
	Sort     int64  `json:"sort"`
	ParentId int64  `json:"parent_id"`
	Status   int64  `json:"status"`
}

type CreateLdapOrganizationReq struct {
	OrganizationName     string `json:"organization_name"`               //组织名
	ParentOrganizationDN string `json:"parent_organization_dn,optional"` //父级dn
	OwnerDN              string `json:"owner_dn,optional"`               //负责人dn
}

type DeleteLdapOrganizationReq struct {
	OrganizationDN string `json:"organization_dn"` //组织dn
}

type UpdateLdapOrganizationReq struct {
	OrganizationDN   string `json:"organization_dn"`   //组织dn
	OrganizationName string `json:"organization_name"` //组织分类名称
}

type CreateLdapUserReq struct {
	UserName     string `json:"user_name"`                   //用户名
	Email        string `json:"email"`                       //邮箱
	Password     string `json:"password"`                    //密码
	Mobile       string `json:"mobile"`                      //手机号
	Avatar       string `json:"avatar"`                      //头像地址
	EmployeeType int64  `json:"employee_type,options=1|2|3"` //1正式 2实习 3外包
	GroupId      int64  `json:"group_id,optional"`           //授权分组id
	Gender       int64  `json:"gender,options=1|2|3"`        //性别 1男 2女 3未知
	Birthday     string `json:"birthday"`                    //生日
	Status       int64  `json:"status,options=0|1"`          //状态 1正常0离职
}

type UpdateLdapUserReq struct {
	UserDN       string `json:"user_dn"`                     //用户dn
	UserName     string `json:"user_name"`                   //用户名
	Mobile       string `json:"mobile,optional"`             //手机号
	Avatar       string `json:"avatar,optional"`             //头像地址
	Status       int64  `json:"status,options=0|1"`          //状态 1正常0离职
	EmployeeType int64  `json:"employee_type,options=1|2|3"` //1正式 2实习 3外包
	GroupId      int64  `json:"group_id,optional"`           //权限分组id
	Gender       int64  `json:"gender,options=1|2|3"`        //性别 1男 2女 3未知
	Birthday     string `json:"birthday"`                    //生日
}

type UpdateLdapUserPwdReq struct {
	UserDN      string `json:"user_dn"` //用户dn
	NewPassword string `json:"new_password"`
	OldPassword string `json:"old_password"`
}

type DeleteLdapUserReq struct {
	UserDN string `json:"user_dn"` //用户dn
}

type GetLdapUserInfoReq struct {
	UserDN string `form:"user_dn"` //用户dn
}

type GetLdapUserInfoRsp struct {
	UserId              int64    `json:"user_id"`
	UserDN              string   `json:"user_dn"`
	UserName            string   `json:"user_name"`            //用户名
	Email               string   `json:"email"`                //邮箱
	Mobile              string   `json:"mobile"`               //手机号
	Avatar              string   `json:"avatar"`               //头像地址
	EmployeeTpye        int64    `json:"employee_tpye"`        //雇佣类型 1正式 2实习 3外包
	Gender              int64    `json:"gender,options=1|2|3"` //性别 1男 2女 3未知
	Birthday            string   `json:"birthday"`             //生日
	BelongOriganization []string `json:"belong_origanization"` //属于哪些部门
	ManageOriganization []string `json:"manage_origanization"` //负责哪些部门
	Status              int64    `json:"status,options=0|1"`   //状态 1正常0离职
}

type AddLdapOrganizationMemberReq struct {
	OrganizationDN string `json:"organization_dn"` //目标组织DN
	UserDN         string `json:"user_dn"`         //用户DN
}

type RemoveLdapOrganizationMemberReq struct {
	OrganizationDN string `json:"organization_dn"` //目标组织DN
	UserDN         string `json:"user_dn"`         //用户DN
}

type GetLdapOrganizationMembersReq struct {
	OrganizationDN string `form:"organization_dn"`
}

type GetLdapOrganizationMembersRsp struct {
	List []GetLdapOrganizationMembersItem `json:"list"`
}

type GetLdapOrganizationMembersItem struct {
	UserId       int64  `json:"userId"`
	UserDN       string `json:"user_dn"`
	UserName     string `json:"user_name"`            //用户名
	Email        string `json:"email"`                //邮箱
	Mobile       string `json:"mobile"`               //手机号
	Avatar       string `json:"avatar"`               //头像地址
	EmployeeType int64  `json:"employee_type"`        //雇佣类型
	Gender       int64  `json:"gender,options=1|2|3"` //性别 1男 2女 3未知
	Birthday     string `json:"birthday"`             //生日
	Status       int64  `json:"status,options=0|1"`   //状态 1正常0离职
}

type GetLdapUsersReq struct {
	PageCookie string `form:"page_cookie,optional"` //下一页分页游标，传空/不传就是第一页
	UserName   string `form:"user_name,optional"`   //用户名用于模糊搜索
}

type GetLdapUsersRsp struct {
	List         []GetLdapUsersItem `json:"list"`
	PagingCookie string             `json:"paging_cookie"`
}

type GetLdapUsersItem struct {
	UserId       int64  `json:"userId"`
	UserDN       string `json:"user_dn"`
	UserName     string `json:"user_name"` //用户名
	Email        string `json:"email"`     //邮箱
	Mobile       string `json:"mobile"`    //手机号
	Avatar       string `json:"avatar"`    //头像地址
	EmployeeType int64  `json:"employee_type"`
	Status       int64  `json:"status,options=0|1"` //状态 1正常0离职
}

type LdapUserLoginReq struct {
	Email    string `json:"email"`
	Password string `json:"password"`
}

type LdapUserLoginRsp struct {
	Token string `json:"token"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"total_count"`
	PageCount   int64 `json:"page_count"`
	CurrentPage int   `json:"current_page"`
	PerPage     int   `json:"per_page"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
